\ To test the ANS Forth Memory-Allocation word set

\ Copyright (C) Gerry Jackson 2006

\ This program is free software; you can redistribute it and/or
\ modify it any way.

\ This program is distributed in the hope that it will be useful,
\ but WITHOUT ANY WARRANTY; without even the implied warranty of
\ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

\ The tests are not claimed to be comprehensive or correct 

\ --------------------------------------------------------------------
\ Version 0.1   Oct 2006 First version released

\ --------------------------------------------------------------------
\ The tests are based on John Hayes test program for the core word set
\ and requires those files to have been loaded

\ Words tested in this file are:
\     allocate free resize
\     
\ --------------------------------------------------------------------
\ Assumptions and dependencies:
\     - running on a case insensitive system. Strictly speaking ANS 
\       Forth words should be in upper case only, this file is mostly
\       lower case
\     - addr -1 allocate and addr -1 resize will return an error
\     - tester.fr has been loaded prior to this file
\     - testing free failing is not done as it is likely to crash the
\       system
\ --------------------------------------------------------------------

Testing Memory-Allocation word set

decimal

\ --------------------------------------------------------------------

Testing allocate free resize

variable addr

{ 100 allocate swap addr ! -> 0 }
{ addr @ 1 cells 1- and -> 0 }		\ Test address is aligned
{ addr @ free -> 0 }

{ 99 allocate swap addr ! -> 0 }

{ addr @ 1 cells 1- and -> 0 }		\ Test address is aligned

{ addr @ free -> 0 }

{ 50 allocate swap addr ! -> 0 }

: writemem 0 do i 1+ over c! 1+ loop drop ;	( ad n -- )

: checkmem  ( ad n --- )
   0
   do
      dup c@ swap >r
      { -> r> i 1+ swap >r }  \ Luckily tester checks can be compiled
      r> 1+
   loop
   drop
;

addr @ 50 writemem addr @ 50 checkmem

{ addr @ 28 resize swap addr ! -> 0 }

addr @ 28 checkmem

{ addr @ 200 resize swap addr ! -> 0 }

{ addr @ 28 checkmem

\ --------------------------------------------------------------------

Testing resize and allocate failure   (unlikely to be enough memory)

{ addr @ -1 resize 0= -> addr @ false }

{ addr @ free -> 0 }

{ -1 allocate nip 0= -> false }		\ Memory allocate failed

\ --------------------------------------------------------------------

cr .( End of Memory-Allocation word tests) cr
