\ To test the ANS Forth String word set

\ Copyright (C) Gerry Jackson 2006

\ This program is free software; you can redistribute it and/or
\ modify it any way.

\ This program is distributed in the hope that it will be useful,
\ but WITHOUT ANY WARRANTY; without even the implied warranty of
\ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

\ The tests are not claimed to be comprehensive or correct 

\ --------------------------------------------------------------------
\ Version 0.1   Oct 2006 First version released

\ --------------------------------------------------------------------
\ The tests are based on John Hayes test program for the core word set
\ and requires those files to have been loaded

\ Words tested in this file are:
\     -trailing /string blank compare search sliteral
\
\ Tests to be added:
\     cmove cmove>
\     
\ --------------------------------------------------------------------
\ Assumptions and dependencies:
\     - running on a case insensitive system. Strictly speaking ANS 
\       Forth words should be in upper case only, this file is mostly
\       lower case
\     - tester.fr has been loaded prior to this file
\     - compare is case sensitive
\ --------------------------------------------------------------------

Testing String word set

decimal

{ :  s1 s" abcdefghijklmnopqrstuvwxyz" ; -> }
{ :  s2 s" abc"   ; -> }
{ :  s3 s" jklmn" ; -> }
{ :  s4 s" z"     ; -> }
{ :  s5 s" mnoq"  ; -> }
{ :  s6 s" 12345" ; -> }
{ :  s7 s" "      ; -> }
{ :  s8 s" abc  " ; -> }
{ :  s9 s"      " ; -> }
{ : s10 s"    a " ; -> }

\ --------------------------------------------------------------------

Testing -trailing

{  s1 -trailing -> s1 }
{  s8 -trailing -> s8 2 - }
{  s7 -trailing -> s7 }
{  s9 -trailing -> s9 drop 0 }
{ s10 -trailing -> s10 1- }

\ --------------------------------------------------------------------

Testing /string

{ s1  5 /string -> s1 swap 5 + swap 5 - }
{ s1 10 /string -4 /string -> s1 6 /string }
{ s1  0 /string -> s1 }

\ --------------------------------------------------------------------

Testing search

{ s1 s2 search -> s1 true }
{ s1 s3 search -> s1  9 /string true }
{ s1 s4 search -> s1 25 /string true }
{ s1 s5 search -> s1 false }
{ s1 s6 search -> s1 false }
{ s1 s7 search -> s1 true }

\ --------------------------------------------------------------------

Testing compare

{ s1 s1 compare -> 0 }
{ s1 pad swap cmove -> }
{ s1 pad over compare -> 0 }
{ s1 pad 6 compare -> 1 }
{ pad 10 s1 compare -> -1 }
{ s1 pad 0 compare -> 1 }
{ pad  0 s1 compare -> -1 }
{ s1 s6 compare ->  1 }
{ s6 s1 compare -> -1 }
{ s1 s" abdde" compare -> -1 }
{ s1 s" abbde" compare ->  1 }
{ s1 s" abcdf"  compare -> -1 }
{ s1 s" abcdee" compare ->  1 }

: s11 s" 0abc" ;
: s12 s" 0aBc" ;

{ s11 s12  compare -> 1 }
{ s12 s11  compare -> -1 }

\ --------------------------------------------------------------------

Testing blank

{ pad 25 char a fill -> }
{ pad 5 + 6 blank -> }
{ pad 12 s" aaaaa      a" compare -> 0 }

\ --------------------------------------------------------------------

Testing sliteral

{ : s13 [ s1 ] sliteral ; -> }
{ s1 s13 compare -> 0 }
{ s1 s13 rot = -rot = -> true false }


\ --------------------------------------------------------------------

cr .( End of String word tests)
